-- name: \\#c0e36f\\Boyo!\\#c0e36f\\
-- description: "What a Lad!" - R.K.V.C.\n\n [Type \\#c0e36f\\'/boyo on'\\#ffffff\\ to become the best duck-like cone to ever exist!]\n\n \\#c0e36f\\Leap\\#ffffff\\ - Hold A and Z while running!\n(Press B to Roll)\n\n\\#c0e36f\\Wall Hop\\#ffffff\\ - Bump, Crash, Dive, or Leap onto a wall!\n(Continue diving to hop up)\n\n\\#c0e36f\\Ground-Pound\\#ffffff\\\n - While GP-ing, press B to... \n(Dive - Midair) (Slide-Kick - Ground)\n\n 




E_MODEL_BOYO = smlua_model_util_get_id("boyo_geo")
E_MODEL_BOYODRIP = smlua_model_util_get_id("boyodrip_geo")
E_MODEL_BOYOGAT = smlua_model_util_get_id("boyogat_geo")
E_MODEL_BROKENBOYO = smlua_model_util_get_id("brokenboyo_geo")
E_MODEL_BROKENBOYODRIP = smlua_model_util_get_id("brokenboyodrip_geo")
E_MODEL_BROKENBOYOGAT = smlua_model_util_get_id("brokenboyogat_geo")


local boyo = 0
local boyodrips = 0
local boyogat = 0
local cannonjump = 0
local sweepdown = 0
local broken = 0

ACT_TAUNT = allocate_mario_action(ACT_GROUP_STATIONARY | ACT_FLAG_STATIONARY | ACT_FLAG_IDLE | ACT_FLAG_PAUSE_EXIT)

gMarioStateExtras = {}
for i=0,(MAX_PLAYERS-1) do
    gMarioStateExtras[i] = {}
    local m = gMarioStates[i]
    local e = gMarioStateExtras[i]
	e.animFrame = 0
	e.rotAngle = 0
	e.watertimer = 0
	e.eyeidletimer = 0
	e.eyehurttimer = 0
	fallrotattimer = 0
end


-- Boyo Text --


function boyo_command(msg)
    if msg == 'on' then
        boyodrips = 0	
        boyo = 1
		boyogat = 0
        djui_chat_message_create('plop! <:D|')
        return true
    elseif msg == 'off' then
        boyodrips = 0	
        boyo = 0
		boyogat = 0
        djui_chat_message_create('QUACK <XD|')
        return true
    elseif msg == 'drips' then
        boyo = 0
        boyodrips = 1	
        boyogat = 0				
        djui_chat_message_create('Lookin Good! <;D| (Jump While Ground-Pounding to Burst yourself into the air!)')
        return true		
    elseif msg == 'gat' then
        boyo = 0
        boyogat = 1	
        boyodrips = 0			
        djui_chat_message_create('WOOSH! <8D| (Health Regeneration while Swimming and a Pretty Neat Dive!)')
        return true				
    end
end


	-- 	if e.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
	--	   e.animFrame = e.animFrame - m.marioObj.header.gfx.animInfo.curAnim.loopEnd	
	--	end
	--		e.animFrame = e.animFrame + 2
	--	end 

	-- Changing in/out of Boyo --


function mario_update(m)
    local e = gMarioStateExtras[m.playerIndex]

    if m.playerIndex == 0 then
        mario_update_local(m)
    end

    if gPlayerSyncTable[m.playerIndex].modelId ~= nil then
        obj_set_model_extended(m.marioObj, gPlayerSyncTable[m.playerIndex].modelId)
    end
end	
	
	
function mario_update_local(m)
    local e = gMarioStateExtras[m.playerIndex]

    if boyo == 1 then
		gPlayerSyncTable[0].modelId = E_MODEL_BOYO
	elseif boyo == 0 and boyodrips == 0 and boyogat == 0 then
        gPlayerSyncTable[0].modelId = nil
    end
	
    if boyodrips == 1 then
		gPlayerSyncTable[0].modelId = E_MODEL_BOYODRIP
    end	
    if boyogat == 1 then
		gPlayerSyncTable[0].modelId = E_MODEL_BOYOGAT
    end	

	
	-- Model and Eye Swaps --
	
	
    if boyo == 1 or boyogat == 1 or boyodrips == 1 then
	local e = gMarioStateExtras[m.playerIndex]	
	
    if	m.health <= 0x450 and broken == 0 and boyo == 1 or m.health <= 0x450 and broken == 0 and boyogat == 1 or m.health <= 0x450 and broken == 0 and boyodrips == 1 then
		play_sound(SOUND_GENERAL_BREAK_BOX, m.marioObj.header.gfx.cameraToObject)
		broken = 1
		m.particleFlags = m.particleFlags | PARTICLE_TRIANGLE		
	end	
    if	broken == 1 and m.health >= 0x450 then
		play_sound(SOUND_GENERAL_SHORT_STAR, m.marioObj.header.gfx.cameraToObject)
		broken = 0
		m.particleFlags = m.particleFlags | PARTICLE_TRIANGLE		
	end		
	
	
    if	m.health <= 0x450 and boyo == 1 then
			gPlayerSyncTable[0].modelId = E_MODEL_BROKENBOYO	
	end	
	
    if	m.health <= 0x450 and boyodrips == 1 then
		gPlayerSyncTable[0].modelId = E_MODEL_BROKENBOYODRIP		
	end		
	
	if	m.health <= 0x450 and boyogat == 1 then
		gPlayerSyncTable[0].modelId = E_MODEL_BROKENBOYOGAT			
	end


    if m.action == ACT_STAR_DANCE_EXIT or m.action == ACT_STAR_DANCE_WATER or m.action == ACT_STAR_DANCE_NO_EXIT or m.action == ACT_UNLOCKING_STAR_DOOR or m.action == ACT_FLAG_RIDING_SHELL then
		m.marioBodyState.eyeState = MARIO_EYES_LOOK_RIGHT
	end		
	
    if (m.action & ACT_FLAG_MOVING) ~= 0 or (m.action & ACT_FLAG_IDLE) ~= 0 and (m.action & ACT_FLAG_SHORT_HITBOX) == 0 and broken == 0 then
		e.eyeidletimer = e.eyeidletimer + 1
			if e.eyeidletimer >= 200 then
				e.eyeidletimer = 0
			end
			if e.eyeidletimer >= 150 then
				m.marioBodyState.eyeState = MARIO_EYES_LOOK_DOWN
			end
		end
    if  (m.action & ACT_FLAG_SHORT_HITBOX) ~= 0 and broken == 0 then
		e.eyeidletimer = e.eyeidletimer + 1
			if e.eyeidletimer >= 300 then
				e.eyeidletimer = 0
			end
			if e.eyeidletimer >= 100 then
				m.marioBodyState.eyeState = MARIO_EYES_LOOK_DOWN
			end
		end		
    if  (m.action & ACT_FLAG_ATTACKING) ~= 0 and broken == 0 or (m.action & ACT_FLAG_HANGING) ~= 0 and broken == 0 or (m.action & ACT_FLAG_WATER_OR_TEXT) ~= 0 and broken == 0 then
		e.eyeidletimer = e.eyeidletimer + 1
			if e.eyeidletimer >= 300 then
				e.eyeidletimer = 0
			end
			if e.eyeidletimer >= 100 then
				m.marioBodyState.eyeState = MARIO_EYES_HALF_CLOSED
			end
		end	
    if  m.health <= 0x450 then
		e.eyehurttimer = e.eyehurttimer + 1
			if e.eyehurttimer >= 0 then
				m.marioBodyState.eyeState = MARIO_EYES_LOOK_UP
			end	
			if e.eyehurttimer >= 50 and m.action ~= ACT_SLEEPING and m.action ~= ACT_START_SLEEPING then	
				m.marioBodyState.eyeState = MARIO_EYES_LOOK_LEFT
			if m.action == ACT_STANDING_DEATH or m.action == ACT_QUICKSAND_DEATH or m.action == ACT_ELECTROCUTION or m.action == ACT_SUFFOCATION or m.action == ACT_DEATH_ON_STOMACH or m.action == ACT_DEATH_ON_BACK or m.action == ACT_EATEN_BY_BUBBA or m.action == ACT_PANTING or m.action == ACT_BURNING_GROUND or m.action == ACT_BURNING_GROUND then 
				m.marioBodyState.eyeState = MARIO_EYES_DEAD		
			end
		end	
	end	
	if  m.health >= 0x450 then
			e.eyehurttimer = 0
		end
	end				
	

	-- GAT --
	

	-- Water Regeneration --

		if boyogat == 1 then
		local e = gMarioStateExtras[m.playerIndex]	

			if (m.action & ACT_FLAG_SWIMMING) ~= 0 then 
				e.watertimer = e.watertimer + 1
			if e.watertimer >= 31 then
				e.watertimer = 0
			end
			if e.watertimer >= 30 then
				m.health = m.health + 110
			end
		end
	end	
	-- Wall Leap --
	
	
    if m.action == ACT_BACKWARD_AIR_KB and boyogat == 1 then
        set_mario_action(m, ACT_DOUBLE_JUMP, 0)
		m.forwardVel = m.forwardVel - 20
		m.vel.y = m.vel.y + 50
		play_sound(SOUND_GENERAL_BOING2, m.marioObj.header.gfx.cameraToObject)
	end	
	
	e.rotAngle = e.rotAngle + 0x2000
	
    if m.action == ACT_DOUBLE_JUMP and boyogat == 1 then
		m.marioObj.header.gfx.angle.y = m.marioObj.header.gfx.angle.y + e.rotAngle	
		m.particleFlags = m.particleFlags | PARTICLE_SNOW
	end		
		
	
	-- GCANNON --
	
	
	if m.action == ACT_LONG_JUMP and boyogat == 1 then
		cannonjump = 1
        set_mario_action(m, ACT_SHOT_FROM_CANNON  , 0)
		m.particleFlags = m.particleFlags | PARTICLE_HORIZONTAL_STAR
		m.particleFlags = m.particleFlags | PARTICLE_MIST_CIRCLE			
        m.forwardVel = m.forwardVel + 25
		play_sound(SOUND_GENERAL_BOING2, m.marioObj.header.gfx.cameraToObject)
	end	
	if m.action ~= ACT_SHOT_FROM_CANNON then
		cannonjump = 0
	end

	-- Dive --
	
	if boyogat == 1 then
	if m.action == ACT_DIVE_SLIDE then
		set_mario_action(m, ACT_WALKING, 0)
	end	

    if m.action == ACT_SLIDE_KICK_SLIDE and (m.input & INPUT_B_PRESSED) ~= 0 then
        set_mario_action(m, ACT_SLIDE_KICK, 0)
		m.vel.y = 10
		m.forwardVel = m.forwardVel + 10
		
	end	

    if m.action == ACT_GROUND_POUND and (m.input & INPUT_B_PRESSED) ~= 0 then
        set_mario_action(m, ACT_DIVE, 0)
		m.forwardVel = m.forwardVel + 50
		m.vel.y = 30
	end	
	
	
	-- Cannon Extended --
	

	if cannonjump == 1 and boyogat == 1 then
		set_mario_animation(m, MARIO_ANIM_SWIM_PART1)
		set_anim_to_frame(m, e.animFrame)
		e.animFrame = m.marioObj.header.gfx.animInfo.curAnim.loopEnd
	end
	if m.action == ACT_SHOT_FROM_CANNON and (m.input & INPUT_B_PRESSED) ~= 0 and boyogat == 1 then
        set_mario_action(m, ACT_DIVE, 0)	
        m.forwardVel = m.forwardVel + 30
		m.vel.y = -30		
	end	
	if m.action == ACT_DIVE or m.action == ACT_SPECIAL_TRIPLE_JUMP and boyogat == 1 then
		m.faceAngle.y = m.intendedYaw
	end		
	-- Speedy Swim --


    if (m.action & ACT_FLAG_WATER_OR_TEXT) ~= 0 and (m.input & INPUT_A_DOWN) ~= 0 and boyogat == 1 then
        m.forwardVel = 100
		m.particleFlags = m.particleFlags | PARTICLE_PLUNGE_BUBBLE		
		end
	end	
	
	-- Leap! --


    if boyo == 1 then
	local e = gMarioStateExtras[m.playerIndex]	
        if m.action == ACT_LONG_JUMP then
			cannonjump = 1
            set_mario_action(m, ACT_SHOT_FROM_CANNON  , 0)
			m.particleFlags = m.particleFlags | PARTICLE_HORIZONTAL_STAR
			m.particleFlags = m.particleFlags | PARTICLE_MIST_CIRCLE			
            m.forwardVel = m.forwardVel + 25
			play_sound(SOUND_GENERAL_BOING1, m.marioObj.header.gfx.cameraToObject)
		if (m.input & INPUT_B_PRESSED) ~= 0 then
			m.forwardVel = m.forwardVel + 50
            set_mario_action(m, ACT_SPECIAL_TRIPLE_JUMP  , 0)
			m.particleFlags = m.particleFlags | PARTICLE_VERTICAL_STAR
			play_sound(SOUND_GENERAL_BOING2, m.marioObj.header.gfx.cameraToObject)		
		end
	end
		if m.action ~= ACT_SHOT_FROM_CANNON then
			cannonjump = 0
		end
	end
    if boyo == 1 or boyodrips == 1 then
    local e = gMarioStateExtras[m.playerIndex]
		if m.action == ACT_DIVE or m.action == ACT_SPECIAL_TRIPLE_JUMP then
			m.faceAngle.y = m.intendedYaw
		end	
		
        if m.action == ACT_SHOT_FROM_CANNON then
			m.marioBodyState.eyeState = MARIO_EYES_DEAD
		end
        if m.action == ACT_SHOT_FROM_CANNON and (m.input & INPUT_B_PRESSED) ~= 0 then
            set_mario_action(m, ACT_SPECIAL_TRIPLE_JUMP  , 0)
			m.particleFlags = m.particleFlags | PARTICLE_VERTICAL_STAR
			play_sound(SOUND_GENERAL_COIN_DROP, m.marioObj.header.gfx.cameraToObject)						
			m.forwardVel = m.forwardVel - 10
		end	
        if m.action == ACT_SPECIAL_TRIPLE_JUMP and (m.pos.y == m.floorHeight) then
		   m.vel.y = 50
        end
		
		
	-- Hardcore Parkour--


    if boyo == 1 or boyodrips == 1 then
    local e = gMarioStateExtras[m.playerIndex]
	
	
	-- Wall Hop --
	
    if m.action == ACT_STEEP_JUMP then
        set_mario_action(m, ACT_BACKFLIP, 0)
		m.vel.y = 45
		m.forwardVel = m.forwardVel + 40
	end			
    if m.action == ACT_BACKWARD_AIR_KB  then
        set_mario_action(m, ACT_BACKFLIP, 0)
		m.forwardVel = m.forwardVel - 20
	end			
    if m.action == ACT_BACKFLIP and (m.input & INPUT_B_PRESSED) ~= 0 then
        set_mario_action(m, ACT_DIVE, 0)
		m.forwardVel = m.forwardVel + 10
	end	
	
	
	-- Speedy Swim --


    if (m.action & ACT_FLAG_WATER_OR_TEXT) ~= 0 and (m.input & INPUT_A_DOWN) ~= 0 then
        m.forwardVel = 100
		m.particleFlags = m.particleFlags | PARTICLE_PLUNGE_BUBBLE		
    end
		
		
	-- Drips G-P Jump --

	
    if boyodrips == 1 then		
    if m.action == ACT_GROUND_POUND_LAND and (m.input & INPUT_A_PRESSED) ~= 0 then
        set_mario_action(m, ACT_TWIRLING, 0)
		m.vel.y = 75
		play_sound(SOUND_GENERAL_BOING2, m.marioObj.header.gfx.cameraToObject)
		m.particleFlags = m.particleFlags | PARTICLE_MIST_CIRCLE
		
		spawn_non_sync_object(
			id_bhvSmoke,
			E_MODEL_SMOKE,
			m.pos.x, m.pos.y + 1, m.pos.z,
	function(o)
            obj_scale_random(o, 4, 2)
    end
    )	
	end
		
    if m.action == ACT_TWIRLING then
		spawn_non_sync_object(
			id_bhvJetStreamWaterRing,
			E_MODEL_WATER_RING,
			m.pos.x, m.pos.y + 1, m.pos.z,
    function(o)
            obj_scale_random(o, 1, 0.5)
	end
    )		
		set_mario_animation(m, MARIO_ANIM_BREAKDANCE)
		set_anim_to_frame(m, e.animFrame)
	if e.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
	   e.animFrame = e.animFrame - m.marioObj.header.gfx.animInfo.curAnim.loopEnd	
	   set_mario_action(m, ACT_TRIPLE_JUMP, 0)
	end
		e.animFrame = e.animFrame + 1
	end
	if m.action == ACT_TWIRLING and (m.input & INPUT_A_DOWN) == 0 then
			set_mario_action(m, ACT_TRIPLE_JUMP, 0)
			m.particleFlags = m.particleFlags | PARTICLE_MIST_CIRCLE
			play_sound(SOUND_GENERAL_GRAND_STAR_JUMP, m.marioObj.header.gfx.cameraToObject)			
		end	
	end


	-- Ground-Pound Dive --


    if boyo == 1 or boyodrips == 1 then
    local e = gMarioStateExtras[m.playerIndex]

    if m.action == ACT_GROUND_POUND and (m.input & INPUT_B_PRESSED) ~= 0 then
        set_mario_action(m, ACT_DIVE, 0)
		m.forwardVel = m.forwardVel + 30
		m.vel.y = 10
				end			
    if m.action == ACT_GROUND_POUND_LAND and (m.input & INPUT_B_PRESSED) ~= 0 then
        set_mario_action(m, ACT_SLIDE_KICK, 0)
		m.forwardVel = m.forwardVel + 40
		
				end		
    if m.action == ACT_SLIDE_KICK_SLIDE and (m.input & INPUT_B_PRESSED) ~= 0 then
        set_mario_action(m, ACT_SLIDE_KICK, 0)
		m.vel.y = 10
		m.forwardVel = m.forwardVel + 10
				end	
			end
		end
	end	
end	
-----------
-- hooks --
-----------


hook_chat_command('boyo', "[on|off|drips|gat]", boyo_command)
hook_event(HOOK_MARIO_UPDATE, mario_update)


-----------
-- 		 --
-----------
